﻿// Проверка правильного порядка следования связанных текстовых фреймов
// v3 (11/21/2023)

var myDoc = app.activeDocument;
if (!myDoc.selection[0])
    {
    alert ("Выделите текстовый фрейм");
    exit();
    }
var myFrames = myDoc.selection[0].parentStory.textContainers;
var n = myFrames.length - 1;
var myOrderlessPages = [];
for (var i = 0; i < n; i++)
    {
    var j = i + 1;
    if (Number (myFrames[i].parentPage.name) > Number (myFrames[j].parentPage.name))
        {
        myFrames[i].parentPage.pageColor = UIColors.ORANGE;
        myFrames[j].parentPage.pageColor = UIColors.ORANGE;
        myOrderlessPages.push(myFrames[i].parentPage.name);
        myOrderlessPages.push(myFrames[j].parentPage.name);
        }
    }
var k = Number (myFrames[n].parentPage.name);
var offset = myFrames[n].parentPage.documentOffset;
var diff = k - offset - 1;
var x = k - diff;
if (myOrderlessPages.length == 0)
    {
    alert ("Проверен диапазон страниц: " + myFrames[0].parentPage.name + "–" 
    + myFrames[n].parentPage.name + ".\nВсе текстовые фреймы на своих местах.");
    try 
        {
        app.windows[0].activePage = myDoc.pages[x];
        } catch (e)  
            {
            alert ("Все страницы проверены");
            }
    } else
        {
        alert ("Проверен диапазон страниц: " + myFrames[0].parentPage.name + "–" 
        + myFrames[n].parentPage.name + ".\nПары страниц, расположенные не по порядку: " + myOrderlessPages.join(", "));
        try
            {
            app.panels.itemByName("$ID/Pages").visible = true;
            } catch (e) {}

        var m = myOrderlessPages[0] - diff - 1;
        app.windows[0].activePage = myDoc.pages[m];
        }
